## StarryNight

Scaffolding and testing tool for creating HIPAA and FDA compliant Meteor apps.  

===============================
#### What is StarryNight?  

StarryNight is a command line tool for use in scaffolding and testing Meteor applications. It's similar to tools like 'rails generate', 'spacejam', and 'mrt'. It's a direct result of 2 years of working on the Meteor Cookbook.

**New Location:  Please note that we've moved to [starrynight.meteorapp.com](starrynight.meteorapp.com)**

===============================
#### Installation  

````
npm install starrynight -g
````

===============================
#### Usage  

````
  autoconfig
  run-tests --type <testType>
  run-tests --framework <frameworkName> --autogenerated
  generate-release-json
  generate-application-json
  display-env
  audit-permissions
  compact
  scaffold --boilerplate <boilerplateName> --framework <frameworkName>
  pattern --url http://github.com/account/repo
  rename --from <originalTerm> --to <newTerm> -root <directoryRoot>
  find-and-replace --from <originalTerm> --to <newTerm> -root <directoryRoot>
  refactor --from <originalTerm> --to <newTerm> -root <directoryRoot>
  create --package foo:mypackage --from /path/to/component
  extract-ids /path/to/<filename>
  extract-classes /path/to/<filename>
  extract-tests-for /path/to/<filename>
  generate-ci  --provider <ciProviderName>
````

===============================
#### Testing Quickstart  

````sh
# fetch files for local development (as definined in .git-packages.json)
$ starrynight fetch

# add .meteor/nightwatch.json to our application
$ starrynight autoconfig

# run your application validation tests using NightWatch
$ starrynight run-tests --type validation

# run your application verification tests using Gagarin
$ starrynight run-tests --type verification

# run your package-verificaiton tests using Gagarin
$ starrynight run-tests --type package-verification

# (optional) add verification & integrations tests to your application
$ starrynight scaffold --framework nightwatch

````


===============================
#### Licensing

![MIT License](https://img.shields.io/badge/license-MIT-blue.svg)
